/*
 * Project: iZariam
 * Edited: 26/02/2012
 * By: ZZJHONS
 * Info: zzjhons@gmail.com
 */

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for `beta_army`
-- ----------------------------
DROP TABLE IF EXISTS `beta_army`;
CREATE TABLE `beta_army` (
  `city` int(11) NOT NULL,
  `army_line` varchar(255) CHARACTER SET utf8 NOT NULL,
  `army_start` int(11) NOT NULL,
  `ships_line` varchar(255) CHARACTER SET utf8 NOT NULL,
  `ships_start` int(11) NOT NULL,
  `phalanx` int(11) NOT NULL,
  `steamgiant` int(11) NOT NULL,
  `spearman` int(11) NOT NULL,
  `swordsman` int(11) NOT NULL,
  `slinger` int(11) NOT NULL,
  `archer` int(11) NOT NULL,
  `marksman` int(11) NOT NULL,
  `ram` int(11) NOT NULL,
  `catapult` int(11) NOT NULL,
  `mortar` int(11) NOT NULL,
  `gyrocopter` int(11) NOT NULL,
  `bombardier` int(11) NOT NULL,
  `cook` int(11) NOT NULL,
  `medic` int(11) NOT NULL,
  `barbarian` int(11) NOT NULL,
  `ship_ram` int(11) NOT NULL,
  `ship_flamethrower` int(11) NOT NULL,
  `ship_steamboat` int(11) NOT NULL,
  `ship_ballista` int(11) NOT NULL,
  `ship_catapult` int(11) NOT NULL,
  `ship_mortar` int(11) NOT NULL,
  `ship_submarine` int(11) NOT NULL,
  `ship_transport` int(11) NOT NULL,
  PRIMARY KEY (`city`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_army
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_banners`
-- ----------------------------
DROP TABLE IF EXISTS `beta_banners`;
CREATE TABLE `beta_banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `frame` text CHARACTER SET utf8 NOT NULL,
  `image` text CHARACTER SET utf8 NOT NULL,
  `link` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_banners
-- ----------------------------

DROP TABLE IF EXISTS `beta_banners_right`;
CREATE TABLE `beta_banners_right` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `frame` text CHARACTER SET utf8 NOT NULL,
  `image` text CHARACTER SET utf8 NOT NULL,
  `link` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for `beta_double_login`
-- ----------------------------
DROP TABLE IF EXISTS `beta_double_login`;
CREATE TABLE `beta_double_login` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `account_from` int(11) NOT NULL,
  `account_to` int(11) NOT NULL,
  `login_time` int(11) NOT NULL,
  `ip_address` varchar(15) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`,`account_from`,`account_to`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_double_login
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_islands`
-- ----------------------------
DROP TABLE IF EXISTS `beta_islands`;
CREATE TABLE `beta_islands` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT 'Island',
  `x` int(11) NOT NULL,
  `y` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '1',
  `trade_resource` int(11) NOT NULL DEFAULT '3',
  `wonder` int(11) NOT NULL DEFAULT '0',
  `wood_level` int(11) NOT NULL DEFAULT '1',
  `trade_level` int(11) NOT NULL DEFAULT '1',
  `wood_count` int(11) NOT NULL DEFAULT '0',
  `trade_count` int(11) NOT NULL DEFAULT '0',
  `wood_start` int(11) NOT NULL DEFAULT '0',
  `trade_start` int(11) NOT NULL DEFAULT '0',
  `city0` int(11) NOT NULL DEFAULT '0',
  `city1` int(11) NOT NULL DEFAULT '0',
  `city2` int(11) NOT NULL DEFAULT '0',
  `city3` int(11) NOT NULL DEFAULT '0',
  `city4` int(11) NOT NULL DEFAULT '0',
  `city5` int(11) NOT NULL DEFAULT '0',
  `city6` int(11) NOT NULL DEFAULT '0',
  `city7` int(11) NOT NULL DEFAULT '0',
  `city8` int(11) NOT NULL DEFAULT '0',
  `city9` int(11) NOT NULL DEFAULT '0',
  `city10` int(11) NOT NULL DEFAULT '0',
  `city11` int(11) NOT NULL DEFAULT '0',
  `city12` int(11) NOT NULL DEFAULT '0',
  `city13` int(11) NOT NULL DEFAULT '0',
  `city14` int(11) NOT NULL DEFAULT '0',
  `city15` int(11) NOT NULL DEFAULT '0',
  `city16` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`name`,`x`,`y`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_islands
-- ----------------------------
INSERT INTO `beta_islands` VALUES ('1', 'Buvios', '1', '1', '2', '4', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('2', 'Angaios', '1', '4', '1', '4', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('3', 'Queoos', '1', '8', '1', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('4', 'Kelatia', '1', '10', '5', '3', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('5', 'Buratia', '1', '17', '4', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('6', 'Whoriios', '1', '18', '3', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('7', 'Taiuios', '1', '19', '2', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('8', 'Horios', '1', '20', '2', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('9', 'Ageitia', '1', '21', '1', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('10', 'Verotia', '2', '2', '4', '4', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('11', 'Sepaios', '2', '3', '5', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('12', 'Croicios', '2', '5', '5', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('13', 'Revios', '2', '7', '2', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('14', 'Rikios', '2', '9', '1', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('15', 'Onaios', '2', '17', '5', '4', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('16', 'Iaaos', '2', '25', '2', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('17', 'Burytia', '3', '2', '2', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('18', 'Blinaios', '3', '5', '3', '1', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('19', 'Llaynios', '3', '8', '5', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('20', 'Foyeos', '3', '13', '5', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('21', 'Urneitia', '3', '17', '1', '4', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('22', 'Striwoios', '3', '23', '5', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('23', 'Ineitia', '4', '7', '4', '2', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('24', 'Rouyios', '4', '8', '5', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('25', 'Nysetia', '4', '13', '1', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('26', 'Likoios', '4', '14', '3', '2', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('27', 'Wubios', '4', '16', '1', '3', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('28', 'Mosautia', '4', '20', '1', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('29', 'Zenios', '4', '24', '1', '2', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('30', 'Haunios', '5', '1', '5', '2', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('31', 'Threcios', '5', '2', '1', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('32', 'Janios', '5', '3', '4', '4', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('33', 'Voigios', '5', '4', '4', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('34', 'Vohios', '5', '5', '1', '4', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('35', 'Whoocios', '5', '9', '3', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('36', 'Daetios', '5', '16', '3', '1', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('37', 'Miluos', '5', '18', '5', '2', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('38', 'Urnoitia', '5', '23', '3', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('39', 'Adaytia', '5', '25', '4', '1', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('40', 'Swoyuos', '6', '1', '1', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('41', 'Doruios', '6', '2', '5', '3', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('42', 'Urneos', '6', '7', '5', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('43', 'Zhaisios', '6', '8', '1', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('44', 'Emuios', '6', '11', '2', '2', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('45', 'Reerios', '6', '14', '3', '3', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('46', 'Lauroos', '6', '17', '5', '2', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('47', 'Kimayos', '6', '19', '1', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('48', 'Gyrios', '6', '22', '3', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('49', 'Delytia', '6', '23', '4', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('50', 'Vymios', '6', '24', '1', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('51', 'Ducaios', '7', '3', '3', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('52', 'Wybios', '7', '5', '4', '1', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('53', 'Oughatia', '7', '10', '5', '1', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('54', 'Hatieos', '7', '12', '5', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('55', 'Shyiaos', '7', '18', '4', '4', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('56', 'Duneios', '7', '20', '3', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('57', 'Entheetia', '7', '23', '4', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('58', 'Sholios', '8', '3', '4', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('59', 'Tantuios', '8', '7', '5', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('60', 'Ageoutia', '8', '9', '1', '1', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('61', 'Clauzaios', '8', '12', '4', '1', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('62', 'Taioos', '8', '14', '3', '4', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('63', 'Syfios', '8', '17', '4', '4', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('64', 'Veuweos', '8', '20', '5', '4', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('65', 'Schuirios', '8', '21', '5', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('66', 'Atetia', '9', '1', '2', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('67', 'Rovios', '9', '2', '2', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('68', 'Chroweios', '9', '3', '1', '1', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('69', 'Quaylios', '9', '6', '5', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('70', 'Sninios', '9', '7', '1', '3', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('71', 'Dakoos', '9', '9', '5', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('72', 'Honitia', '9', '10', '1', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('73', 'Tehyios', '9', '14', '5', '4', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('74', 'Rahios', '9', '19', '2', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('75', 'Uskeuos', '9', '22', '1', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('76', 'Straidios', '9', '25', '3', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('77', 'Sackyos', '10', '3', '5', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('78', 'Peroeos', '10', '4', '2', '3', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('79', 'Untutia', '10', '6', '2', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('80', 'Smakios', '10', '8', '3', '1', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('81', 'Takios', '10', '9', '5', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('82', 'Mosuos', '10', '10', '4', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('83', 'Swauxuos', '10', '17', '2', '1', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('84', 'Tysoios', '10', '22', '5', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('85', 'Wotios', '11', '9', '4', '1', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('86', 'Lihios', '11', '11', '3', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('87', 'Samootia', '11', '13', '4', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('88', 'Ildetia', '11', '14', '3', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('89', 'Yeritia', '11', '15', '3', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('90', 'Soixios', '11', '16', '1', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('91', 'Aleeos', '11', '18', '4', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('92', 'Silios', '11', '23', '5', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('93', 'Royios', '11', '25', '5', '3', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('94', 'Engoios', '12', '1', '5', '2', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('95', 'Skeloos', '12', '2', '1', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('96', 'Fuyyos', '12', '8', '4', '1', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('97', 'Cedios', '12', '14', '2', '2', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('98', 'Snoduos', '12', '18', '3', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('99', 'Cosios', '12', '19', '3', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('100', 'Untyos', '12', '20', '4', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('101', 'Threkios', '12', '22', '1', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('102', 'Josios', '12', '23', '1', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('103', 'Lleuhuos', '12', '25', '3', '4', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('104', 'Seyckoos', '13', '3', '2', '2', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('105', 'Bloenios', '13', '7', '2', '4', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('106', 'Nusiios', '13', '8', '5', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('107', 'Kuchiios', '13', '11', '5', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('108', 'Shyitia', '13', '12', '5', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('109', 'Layiios', '13', '13', '5', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('110', 'Angouos', '13', '18', '5', '2', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('111', 'Dagios', '13', '19', '5', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('112', 'Nauyios', '13', '20', '1', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('113', 'Dagios', '13', '21', '4', '2', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('114', 'Sluzios', '13', '22', '5', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('115', 'Nautoos', '13', '25', '2', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('116', 'Echotia', '14', '1', '1', '2', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('117', 'Athytia', '14', '2', '3', '3', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('118', 'Cukios', '14', '3', '1', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('119', 'Zukyos', '14', '5', '5', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('120', 'Aruos', '14', '6', '4', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('121', 'Staltaos', '14', '10', '4', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('122', 'Kaisios', '14', '17', '4', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('123', 'Deleios', '14', '20', '2', '1', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('124', 'Bluldios', '14', '22', '2', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('125', 'Enoitia', '14', '24', '5', '3', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('126', 'Umyos', '14', '25', '4', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('127', 'Brivios', '15', '4', '4', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('128', 'Gerios', '15', '6', '4', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('129', 'Dynatia', '15', '8', '4', '4', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('130', 'Aughatia', '15', '9', '1', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('131', 'Gepios', '15', '11', '5', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('132', 'Staugios', '15', '12', '2', '1', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('133', 'Llisyios', '15', '13', '2', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('134', 'Killoos', '15', '14', '2', '1', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('135', 'Slijios', '15', '17', '4', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('136', 'Smounaos', '15', '19', '1', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('137', 'Lluisaos', '15', '20', '4', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('138', 'Yerytia', '15', '21', '2', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('139', 'Toneaos', '15', '23', '5', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('140', 'Ritaos', '15', '24', '3', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('141', 'Zhecios', '16', '1', '4', '3', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('142', 'Echuitia', '16', '3', '1', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('143', 'Yimios', '16', '4', '4', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('144', 'Ageotia', '16', '6', '1', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('145', 'Nysaeos', '16', '8', '4', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('146', 'Phojios', '16', '9', '3', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('147', 'Oldooos', '16', '13', '3', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('148', 'Nedios', '16', '17', '4', '3', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('149', 'Issaos', '16', '19', '4', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('150', 'Aughuos', '16', '21', '2', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('151', 'Rabios', '16', '22', '1', '2', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('152', 'Esteutia', '16', '23', '5', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('153', 'Imaytia', '16', '24', '2', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('154', 'Wavios', '17', '2', '4', '4', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('155', 'Trodyos', '17', '5', '1', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('156', 'Enieos', '17', '7', '1', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('157', 'Layrios', '17', '8', '5', '4', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('158', 'Voofios', '17', '9', '1', '1', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('159', 'Oriaos', '17', '11', '5', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('160', 'Swaishoios', '17', '12', '1', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('161', 'Beyreios', '17', '14', '3', '4', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('162', 'Burauos', '17', '17', '5', '1', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('163', 'Zyhiios', '17', '18', '4', '3', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('164', 'Llafios', '17', '23', '2', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('165', 'Smaeghiios', '17', '25', '3', '3', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('166', 'Ashaos', '18', '2', '3', '4', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('167', 'Drorios', '18', '11', '1', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('168', 'Wutios', '18', '12', '5', '1', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('169', 'Nysytia', '18', '13', '2', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('170', 'Solios', '18', '14', '1', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('171', 'Caniios', '18', '16', '4', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('172', 'Chaeitia', '18', '17', '2', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('173', 'Llocoios', '18', '18', '4', '2', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('174', 'Wareatia', '18', '21', '3', '3', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('175', 'Woretia', '18', '24', '2', '3', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('176', 'Lliaruios', '18', '25', '5', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('177', 'Enaeos', '19', '1', '3', '4', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('178', 'Phynaos', '19', '2', '3', '1', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('179', 'Clizios', '19', '3', '4', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('180', 'Leiboios', '19', '4', '3', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('181', 'Newios', '19', '6', '2', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('182', 'Dopyios', '19', '10', '3', '1', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('183', 'Fusios', '19', '12', '5', '2', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('184', 'Zaujios', '19', '16', '5', '2', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('185', 'Aduos', '19', '20', '2', '2', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('186', 'Rhoesios', '19', '25', '2', '1', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('187', 'Oreos', '20', '2', '3', '4', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('188', 'Taweios', '20', '5', '2', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('189', 'Oughyos', '20', '9', '3', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('190', 'Recios', '20', '13', '1', '1', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('191', 'Rookios', '20', '17', '5', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('192', 'Sossyos', '20', '18', '1', '2', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('193', 'Drichuos', '20', '22', '1', '1', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('194', 'Neyduos', '20', '25', '2', '1', '8', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('195', 'Zzjhons', '20', '21', '5', '3', '6', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('196', 'Ancient', '20', '20', '3', '2', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('197', 'Caribe', '19', '21', '1', '4', '2', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('198', 'Turtle', '19', '22', '4', '1', '7', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('199', 'Royal', '18', '22', '2', '2', '5', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `beta_islands` VALUES ('200', 'Paradise', '18', '20', '5', '3', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');

-- ----------------------------
-- Table structure for `beta_missions`
-- ----------------------------
DROP TABLE IF EXISTS `beta_missions`;
CREATE TABLE `beta_missions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `from` int(11) NOT NULL,
  `to` int(11) NOT NULL,
  `loading_from_start` int(11) NOT NULL,
  `loading_to_start` int(11) NOT NULL,
  `mission_type` int(11) NOT NULL,
  `mission_start` int(11) NOT NULL,
  `return_start` int(11) NOT NULL,
  `wood` int(11) NOT NULL,
  `wine` int(11) NOT NULL,
  `marble` int(11) NOT NULL,
  `crystal` int(11) NOT NULL,
  `sulfur` int(11) NOT NULL,
  `gold` int(11) NOT NULL DEFAULT '0',
  `peoples` int(11) NOT NULL,
  `phalanx` int(11) NOT NULL,
  `steamgiant` int(11) NOT NULL,
  `spearman` int(11) NOT NULL,
  `swordsman` int(11) NOT NULL,
  `slinger` int(11) NOT NULL,
  `archer` int(11) NOT NULL,
  `marksman` int(11) NOT NULL,
  `ram` int(11) NOT NULL,
  `catapult` int(11) NOT NULL,
  `mortar` int(11) NOT NULL,
  `gyrocopter` int(11) NOT NULL,
  `bombardier` int(11) NOT NULL,
  `cook` int(11) NOT NULL,
  `medic` int(11) NOT NULL,
  `barbarian` int(11) NOT NULL,
  `ship_ram` int(11) NOT NULL,
  `ship_flamethrower` int(11) NOT NULL,
  `ship_steamboat` int(11) NOT NULL,
  `ship_ballista` int(11) NOT NULL,
  `ship_catapult` int(11) NOT NULL,
  `ship_mortar` int(11) NOT NULL,
  `ship_submarine` int(11) NOT NULL,
  `ship_transport` int(11) NOT NULL,
  `percent` varchar(11) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `trade_wood_count` int(11) NOT NULL,
  `trade_wine_count` int(11) NOT NULL,
  `trade_marble_count` int(11) NOT NULL,
  `trade_crystal_count` int(11) NOT NULL,
  `trade_sulfur_count` int(11) NOT NULL,
  `trade_gold_count` int(11) NOT NULL,
  `trade_wood_cost` int(11) NOT NULL,
  `trade_wine_cost` int(11) NOT NULL,
  `trade_marble_cost` int(11) NOT NULL,
  `trade_crystal_cost` int(11) NOT NULL,
  `trade_sulfur_cost` int(11) NOT NULL,
  PRIMARY KEY (`id`,`user`,`from`,`to`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_missions
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_notes`
-- ----------------------------
DROP TABLE IF EXISTS `beta_notes`;
CREATE TABLE `beta_notes` (
  `user` int(11) NOT NULL,
  `text` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`user`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_notes
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_research`
-- ----------------------------
DROP TABLE IF EXISTS `beta_research`;
CREATE TABLE `beta_research` (
  `user` int(11) NOT NULL,
  `points` varchar(255) COLLATE latin1_general_ci NOT NULL DEFAULT '0',
  `res1_1` int(11) NOT NULL,
  `res1_2` int(11) NOT NULL,
  `res1_3` int(11) NOT NULL,
  `res1_4` int(11) NOT NULL,
  `res1_5` int(11) NOT NULL,
  `res1_6` int(11) NOT NULL,
  `res1_7` int(11) NOT NULL,
  `res1_8` int(11) NOT NULL,
  `res1_9` int(11) NOT NULL,
  `res1_10` int(11) NOT NULL,
  `res1_11` int(11) NOT NULL,
  `res1_12` int(11) NOT NULL,
  `res1_13` int(11) NOT NULL,
  `res1_14` int(11) NOT NULL,
  `res2_1` int(11) NOT NULL,
  `res2_2` int(11) NOT NULL,
  `res2_3` int(11) NOT NULL,
  `res2_4` int(11) NOT NULL,
  `res2_5` int(11) NOT NULL,
  `res2_6` int(11) NOT NULL,
  `res2_7` int(11) NOT NULL,
  `res2_8` int(11) NOT NULL,
  `res2_9` int(11) NOT NULL,
  `res2_10` int(11) NOT NULL,
  `res2_11` int(11) NOT NULL,
  `res2_12` int(11) NOT NULL,
  `res2_13` int(11) NOT NULL,
  `res2_14` int(11) NOT NULL,
  `res2_15` int(11) NOT NULL,
  `res3_1` int(11) NOT NULL,
  `res3_2` int(11) NOT NULL,
  `res3_3` int(11) NOT NULL,
  `res3_4` int(11) NOT NULL,
  `res3_5` int(11) NOT NULL,
  `res3_6` int(11) NOT NULL,
  `res3_7` int(11) NOT NULL,
  `res3_8` int(11) NOT NULL,
  `res3_9` int(11) NOT NULL,
  `res3_10` int(11) NOT NULL,
  `res3_11` int(11) NOT NULL,
  `res3_12` int(11) NOT NULL,
  `res3_13` int(11) NOT NULL,
  `res3_14` int(11) NOT NULL,
  `res3_15` int(11) NOT NULL,
  `res3_16` int(11) NOT NULL,
  `res4_1` int(11) NOT NULL,
  `res4_2` int(11) NOT NULL,
  `res4_3` int(11) NOT NULL,
  `res4_4` int(11) NOT NULL,
  `res4_5` int(11) NOT NULL,
  `res4_6` int(11) NOT NULL,
  `res4_7` int(11) NOT NULL,
  `res4_8` int(11) NOT NULL,
  `res4_9` int(11) NOT NULL,
  `res4_10` int(11) NOT NULL,
  `res4_11` int(11) NOT NULL,
  `res4_12` int(11) NOT NULL,
  `res4_13` int(11) NOT NULL,
  `res4_14` int(11) NOT NULL,
  `way1_checked` int(11) NOT NULL,
  `way2_checked` int(11) NOT NULL,
  `way3_checked` int(11) NOT NULL,
  `way4_checked` int(11) NOT NULL,
  PRIMARY KEY (`user`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_research
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_spyes`
-- ----------------------------
DROP TABLE IF EXISTS `beta_spyes`;
CREATE TABLE `beta_spyes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `from` int(11) NOT NULL,
  `to` int(11) NOT NULL,
  `risk` int(11) NOT NULL,
  `last_update` int(11) NOT NULL,
  `mission_type` int(11) NOT NULL,
  `mission_start` int(11) NOT NULL,
  PRIMARY KEY (`id`,`user`,`from`,`to`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_spyes
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_spy_messages`
-- ----------------------------
DROP TABLE IF EXISTS `beta_spy_messages`;
CREATE TABLE `beta_spy_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `spy` int(11) NOT NULL,
  `from` int(11) NOT NULL,
  `to` int(11) NOT NULL,
  `mission` int(11) NOT NULL,
  `date` int(11) NOT NULL,
  `desc` text CHARACTER SET utf8 NOT NULL,
  `text` text CHARACTER SET utf8 NOT NULL,
  `checked` int(11) NOT NULL,
  PRIMARY KEY (`id`,`user`,`spy`,`from`,`to`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_spy_messages
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_towns`
-- ----------------------------
DROP TABLE IF EXISTS `beta_towns`;
CREATE TABLE `beta_towns` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `island` int(11) NOT NULL,
  `position` int(11) NOT NULL DEFAULT '0',
  `last_update` int(11) NOT NULL,
  `name` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT 'Polis',
  `wood` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '500',
  `wine` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `marble` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `crystal` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `sulfur` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `pos0_type` int(11) NOT NULL DEFAULT '1',
  `pos0_level` int(11) NOT NULL DEFAULT '1',
  `pos1_type` int(11) NOT NULL DEFAULT '0',
  `pos1_level` int(11) NOT NULL DEFAULT '0',
  `pos2_type` int(11) NOT NULL DEFAULT '0',
  `pos2_level` int(11) NOT NULL DEFAULT '0',
  `pos3_type` int(11) NOT NULL DEFAULT '0',
  `pos3_level` int(11) NOT NULL DEFAULT '0',
  `pos4_type` int(11) NOT NULL DEFAULT '0',
  `pos4_level` int(11) NOT NULL DEFAULT '0',
  `pos5_type` int(11) NOT NULL DEFAULT '0',
  `pos5_level` int(11) NOT NULL DEFAULT '0',
  `pos6_type` int(11) NOT NULL DEFAULT '0',
  `pos6_level` int(11) NOT NULL DEFAULT '0',
  `pos7_type` int(11) NOT NULL DEFAULT '0',
  `pos7_level` int(11) NOT NULL DEFAULT '0',
  `pos8_type` int(11) NOT NULL DEFAULT '0',
  `pos8_level` int(11) NOT NULL DEFAULT '0',
  `pos9_type` int(11) NOT NULL DEFAULT '0',
  `pos9_level` int(11) NOT NULL,
  `pos10_type` int(11) NOT NULL DEFAULT '0',
  `pos10_level` int(11) NOT NULL DEFAULT '0',
  `pos11_type` int(11) NOT NULL DEFAULT '0',
  `pos11_level` int(11) NOT NULL DEFAULT '0',
  `pos12_type` int(11) NOT NULL DEFAULT '0',
  `pos12_level` int(11) NOT NULL DEFAULT '0',
  `pos13_type` int(11) NOT NULL DEFAULT '0',
  `pos13_level` int(11) NOT NULL DEFAULT '0',
  `pos14_type` int(11) NOT NULL DEFAULT '0',
  `pos14_level` int(11) NOT NULL DEFAULT '0',
  `build_line` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `build_start` int(11) NOT NULL DEFAULT '0',
  `peoples` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '40',
  `workers` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `tradegood` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `scientists` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `templer` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '0',
  `spyes` int(11) NOT NULL,
  `spyes_start` int(11) NOT NULL,
  `workers_wood` int(11) NOT NULL DEFAULT '0',
  `tradegood_wood` int(11) NOT NULL DEFAULT '0',
  `actions` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '3',
  `tavern_wine` int(11) NOT NULL DEFAULT '0',
  `branch_search_type` int(11) NOT NULL DEFAULT '0',
  `branch_search_resource` int(11) NOT NULL DEFAULT '0',
  `branch_search_radius` int(11) NOT NULL DEFAULT '1',
  `branch_trade_wood_type` int(11) NOT NULL DEFAULT '1',
  `branch_trade_wine_type` int(11) NOT NULL DEFAULT '1',
  `branch_trade_marble_type` int(11) NOT NULL DEFAULT '1',
  `branch_trade_crystal_type` int(11) NOT NULL DEFAULT '1',
  `branch_trade_sulfur_type` int(11) NOT NULL DEFAULT '1',
  `branch_trade_wood_count` int(11) NOT NULL DEFAULT '0',
  `branch_trade_wine_count` int(11) NOT NULL DEFAULT '0',
  `branch_trade_marble_count` int(11) NOT NULL DEFAULT '0',
  `branch_trade_crystal_count` int(11) NOT NULL DEFAULT '0',
  `branch_trade_sulfur_count` int(11) NOT NULL DEFAULT '0',
  `branch_trade_wood_cost` int(11) NOT NULL DEFAULT '0',
  `branch_trade_wine_cost` int(11) NOT NULL DEFAULT '0',
  `branch_trade_marble_cost` int(11) NOT NULL DEFAULT '0',
  `branch_trade_crystal_cost` int(11) NOT NULL DEFAULT '0',
  `branch_trade_sulfur_cost` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`user`,`island`,`position`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_towns
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_town_messages`
-- ----------------------------
DROP TABLE IF EXISTS `beta_town_messages`;
CREATE TABLE `beta_town_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `town` int(11) NOT NULL,
  `date` int(11) NOT NULL,
  `text` text CHARACTER SET utf8 NOT NULL,
  `checked` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`user`,`town`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_town_messages
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_trade_routes`
-- ----------------------------
DROP TABLE IF EXISTS `beta_trade_routes`;
CREATE TABLE `beta_trade_routes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `from` int(11) NOT NULL,
  `to` int(11) NOT NULL,
  `start_time` int(11) NOT NULL,
  `update_time` int(11) NOT NULL,
  `send_resource` int(11) NOT NULL,
  `send_time` int(11) NOT NULL,
  `send_count` int(11) NOT NULL,
  PRIMARY KEY (`id`,`user`,`from`,`to`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of beta_trade_routes
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_users`
-- ----------------------------
DROP TABLE IF EXISTS `beta_users`;
CREATE TABLE `beta_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(255) CHARACTER SET utf8 NOT NULL,
  `password` varchar(255) CHARACTER SET utf8 NOT NULL,
  `email` varchar(255) CHARACTER SET utf8 NOT NULL,
  `access` int(11) NOT NULL DEFAULT '0',
  `register_key` varchar(255) CHARACTER SET utf8 NOT NULL,
  `register_complete` int(11) NOT NULL DEFAULT '0',
  `last_visit` int(11) NOT NULL,
  `double_login` int(11) NOT NULL DEFAULT '0',
  `blocked_time` int(11) NOT NULL DEFAULT '0',
  `blocked_why` text CHARACTER SET utf8 NOT NULL,
  `town` int(11) NOT NULL,
  `capital` int(11) NOT NULL,
  `gold` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '100',
  `ambrosy` int(11) NOT NULL DEFAULT '1000',
  `transports` int(11) NOT NULL DEFAULT '0',
  `tutorial` int(11) NOT NULL DEFAULT '0',
  `premium_account` int(11) NOT NULL DEFAULT '0',
  `premium_wood` int(11) NOT NULL DEFAULT '0',
  `premium_marble` int(11) NOT NULL DEFAULT '0',
  `premium_sulfur` int(11) NOT NULL DEFAULT '0',
  `premium_crystal` int(11) NOT NULL DEFAULT '0',
  `premium_wine` int(11) NOT NULL DEFAULT '0',
  `premium_capacity` int(11) NOT NULL DEFAULT '0',
  `options_select` int(11) NOT NULL DEFAULT '1',
  `points` float(11,0) NOT NULL DEFAULT '0',
  `points_buildings` float(11,0) NOT NULL DEFAULT '0',
  `points_levels` float(11,0) NOT NULL DEFAULT '0',
  `points_peoples` float(11,0) NOT NULL DEFAULT '0',
  `points_research` float(11,0) NOT NULL DEFAULT '0',
  `points_complete` float(11,0) NOT NULL DEFAULT '0',
  `points_army` float(11,0) NOT NULL DEFAULT '0',
  `points_gold` float(11,0) NOT NULL DEFAULT '0',
  `points_transports` float(11,0) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`login`,`town`,`capital`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_users
-- ----------------------------

-- ----------------------------
-- Table structure for `beta_user_messages`
-- ----------------------------
DROP TABLE IF EXISTS `beta_user_messages`;
CREATE TABLE `beta_user_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `from` int(11) NOT NULL,
  `to` int(11) NOT NULL,
  `type` int(11) NOT NULL,
  `date` int(11) NOT NULL,
  `text` text CHARACTER SET utf8 NOT NULL,
  `checked_from` int(11) NOT NULL,
  `checked_to` int(11) NOT NULL,
  `deleted_from` int(11) NOT NULL,
  `deleted_to` int(11) NOT NULL,
  `archived_from` int(11) NOT NULL,
  `archived_to` int(11) NOT NULL,
  PRIMARY KEY (`id`,`from`,`to`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records of beta_user_messages
-- ----------------------------